
/*
2017-09-18
    Heizung beim Linkslauf aus
    Drehrichtung umgekehrt
2017-08-26
    Erste Probeläufe

------------------------------

     Ablauf:
        Einschalten
        Zeit einstellen.
        Wenn Tür zu und 5s die Zeit nicht verstellt wurde: Starten.
        Wenn Zeit bis auf 10min abgelaufen: Heizung aus, kalt weiterlaufen
        Wenn Zeit abgelaufen: Jede Minute die Trommel kurz drehen zum auflockern    


      Bei Linkslauf läuft das Gebläse so gut wie gar nicht. Daher wird dabei die Heizung abgeschaltet.
*/

/*  --- nicht implementiert ---
  Temperature Sensor DS18B20 an Digitalen Port Pin 12 wie folgt verbunden
  Links=Masse,  (Chip liegt auf Rundung; Schrift ist lesbar; Beine zeigen zu mir)
  Mitte=Data,
  Rechts=+5V,
  3300 to 4700 Ohm Widerstand von +5V nach Data.

*/
/* Benötigte Bibliotheken importieren */
//#include <OneWire.h>
//#include <DallasTemperature.h>
//#include <SPI.h>
#include <toneAC.h>  //Uses Pin9+10 on Mega328. 100Ohm + Piezo
#include "MAX7219.h"
#include <avr/wdt.h>/*

  #define DO_MOTOR                2   //REL1 - Motor EIN
  #define DO_MOTOR_REVERS         3   //REL2 - Motor Richtung
  #define DO_HEIZUNG              4   //REL3
  #define DO_LICHT                5   //REL4 - bisher nicht benutzt
*/

#define DO_LICHT                 2   //REL1 - bisher nicht benutzt
#define DO_MOTOR_RECHTS          3   //REL2 
#define DO_MOTOR_LINKS           4   //REL3 
#define DO_HEIZUNG               5   //REL4
//6   : LED DataIn
//7   : LED CLK
//8   : LED LOAD

#define DO_PIEZOa               9
#define DO_PIEZOb               10
#define DI_WASSER               11
#define DI_TUER                 12

//#define DO_PIEZOa              9    //fixed use in toneAC
//#define DO_PIEZOb              10   //fixed use in toneAC
#define DO_LED_Run              13

#define AI_Poti                 A0
#define DO_LED_Wasser           A1
#define DO_LED_Flusen           A2
#define DO_MOTOR_TRIAC          A5  //Triac für Motor EIN   (Hinweis: A6 und A7 gehen wohl nicht am Nano)

//Die Relais haben Optokoppler mit gemeinsamer Anode.
//Also schaltet LOW auf einem Ausgangsport das Relais ein.
#define MOTOR_AUS {digitalWrite(DO_MOTOR_TRIAC,  LOW); delay(50); digitalWrite(DO_MOTOR_LINKS, HIGH); digitalWrite(DO_MOTOR_RECHTS, HIGH);}
#define MOTOR_L   {digitalWrite(DO_MOTOR_LINKS,  LOW); delay(30); digitalWrite(DO_MOTOR_TRIAC, HIGH); }
#define MOTOR_R   {digitalWrite(DO_MOTOR_RECHTS, LOW); delay(30); digitalWrite(DO_MOTOR_TRIAC, HIGH); }


#define HEIZUNG_AUS digitalWrite(DO_HEIZUNG, HIGH)
#define HEIZUNG_EIN digitalWrite(DO_HEIZUNG, LOW)

#define LICHT_AUS digitalWrite(DO_LICHT, HIGH)
#define LICHT_EIN digitalWrite(DO_LICHT, LOW)

#define TUER_IST_ZU (!digitalRead(DI_TUER))
#define TUER_IST_AUF digitalRead(DI_TUER)

#define WASSER_OK   (!digitalRead(DI_WASSER))
#define WASSER_ERROR digitalRead(DI_WASSER)


#define CYCLE_TIME_MS           20L  /* ms */

//OneWire ourWire(DS18B20); /* Ini oneWire instance */
//DallasTemperature sensors(&ourWire);/* Dallas Temperature Library fuer Nutzung der oneWire Library vorbereiten */
/*
  We need a LedControl to work with.
  pin 6 is connected to the DataIn
  pin 7 is connected to the CLK
  pin 8 is connected to LOAD
  We have only a single MAX7219.
*/
LedControl display = LedControl(6, 7, 8); //DataIn, CLK, LOAD


long int remainingMilliseconds = 90L * 60L * 1000L; //90min
unsigned long lastmillis;
int status = 0;
int errorStatus = 0;
int MotorStatus = 0;
bool displayNeedsRefresh = false;

bool disp_h2o = false;
bool disp_fluff = false;
bool disp_door = false;
bool disp_time = true;
bool disp_end = false;


//-----------------------------------------------------------------------------
bool readTimeValue() { //Returns TRUE if value has changed
  //-----------------------------------------------------------------------------
  static int oldVal = 2000;
  int val;
  int t;
  val = analogRead(AI_Poti);  //0..1023
  if (abs(oldVal - val) > 40) { //Hysterese
    oldVal = val;
    //wandeln in 10..120min  = 12 Schritte
    t = val / 85 + 1;
    if (t > 12) t = 12;
    remainingMilliseconds = (long int)t * (1000L * 60L * 10L); // t * 10min; also 10min..120min;
    //remainingMilliseconds = (long int)t * (1000L * 90L * 1L); // t * 1.5min; also 1.5min..18min;  //Zum testen
    displayNeedsRefresh = true;
    return true;
  }
  return false;
}


//-----------------------------------------------------------------------------
void displayTime(void) { //uses global remainingMilliseconds; sets global displayNeedsRefresh
  //-----------------------------------------------------------------------------
  int minuten;
  long int sekunden;
  displayNeedsRefresh = false;
  sekunden = (remainingMilliseconds + 999L) / 1000L; //Aufrunden
  minuten = (int)(sekunden / 60L);
  sekunden %= 60L;
  //Serial.print("#");   //Clear LCD, go home
  //Serial.print(minuten);
  //Serial.print(":");
  //if (sekunden < 10)   Serial.print("0");
  //Serial.println(sekunden);

  //Layout: 76543 210
  //          120.59

  //void setDigit(int addr, int digit, byte value, boolean dp);
  display.setChar( 0, ' ', false);
  display.setDigit( 1, sekunden % 10, false);
  display.setDigit( 2, sekunden / 10, false);
  display.setDigit( 3, minuten % 10, true);
  minuten /= 10;
  if (0 == minuten) {
    display.setChar(4, ' ', false);
  } else {
    display.setDigit(4, minuten % 10, false);
  }
  minuten /= 10;
  if (0 == minuten) {
    display.setChar(5, ' ', false);
  } else {
    display.setDigit(5, minuten % 10, false);
  }
  display.setChar(6, ' ', false);
  display.setChar(7, ' ', false);
}

//-----------------------------------------------------------------------------
void displayInfo(int n) {
  //-----------------------------------------------------------------------------
  //Layout: 76543210
  //          h2o
  //         FLUFF
  //         door
  switch (n) {
    case 1:
      display.setChar(7, ' ', false);
      display.setChar(6, ' ', false);
      display.setChar(5, 'h', false);
      display.setChar(4, '2', false);
      display.setChar(3, 'o', false);
      display.setChar(2, ' ', false);
      display.setChar(1, ' ', false);
      display.setChar(0, ' ', false);
      break;
    case 2:
      display.setChar(7, ' ', false);
      display.setChar(6, ' ', false);
      display.setChar(5, 'F', false);
      display.setChar(4, 'L', false);
      display.setChar(3, 'U', false);
      display.setChar(2, 'F', false);
      display.setChar(1, 'F', false);
      display.setChar(0, ' ', false);
      break;
    case 3:
      display.setChar(7, ' ', false);
      display.setChar(6, ' ', false);
      display.setChar(5, 'd', false);
      display.setChar(4, 'o', false);
      display.setChar(3, 'o', false);
      display.setChar(2, 'r', false);
      display.setChar(1, ' ', false);
      display.setChar(0, ' ', false);
      break;
    case 4:
      display.setChar(7, ' ', false);
      display.setChar(6, '-', false);
      display.setChar(5, 'E', false);
      display.setChar(4, 'n', false);
      display.setChar(3, 'd', false);
      display.setChar(2, '-', false);
      display.setChar(1, ' ', false);
      display.setChar(0, ' ', false);
      break;
  }
}

//-----------------------------------------------------------------------------
void refreshDisplay(bool showTime) {
  //-----------------------------------------------------------------------------
  static byte step = 1;
  bool done = false;
  byte round = 0;
  display.shutdown(false);
  //display.clearDisplay(); Unnötig, da immer alle 8 Stellen geschrieben werden.
  if (showTime) step = 0;
  do {
    switch (step) {
      case 1:
        if (disp_time) {
          displayTime();
          done = true;
        }
        break;
      case 2:
        if (disp_h2o) {
          displayInfo(1);
          done = true;
        }
        break;
      case 3:
        if (disp_door) {
          displayInfo(3);
          done = true;
        }
        break;
      case 4:
        if (disp_fluff) {
          displayInfo(2);
          done = true;
        }
        break;
      case 5:
        if (disp_end) {
          displayInfo(4);
          done = true;
        }
        break;
      case 6:
        round++;
        if (round < 2) {
          step = 0;
        } else {
          done = true;
        }
        break;
	  default:
        done = true;	  
		break;
    } //switch
    step++;
  } while (!done);
}


//-----------------------------------------------------------------------------
void setup()
//-----------------------------------------------------------------------------
{
  int i;
  MOTOR_AUS;
  HEIZUNG_AUS;
  LICHT_AUS;

  pinMode(DO_HEIZUNG,         OUTPUT);    HEIZUNG_AUS;
  pinMode(DO_MOTOR_LINKS,     OUTPUT);
  pinMode(DO_MOTOR_RECHTS,    OUTPUT);    MOTOR_AUS;
  pinMode(DO_LICHT,           OUTPUT);    LICHT_AUS;


  pinMode(DO_PIEZOa,          OUTPUT);
  pinMode(DO_PIEZOb,          OUTPUT);

  pinMode(DO_LED_Run,         OUTPUT);
  pinMode(DO_LED_Wasser,      OUTPUT);
  pinMode(DO_LED_Flusen,      OUTPUT);

  pinMode(DI_WASSER,          INPUT_PULLUP);
  pinMode(DI_TUER,            INPUT_PULLUP);
  pinMode(AI_Poti,            INPUT);

  /* Display is already initialized
    pinMode(6, OUTPUT);
    pinMode(7, OUTPUT);
    pinMode(8, OUTPUT);
  */
  pinMode(DO_MOTOR_TRIAC,     OUTPUT);
  // initialize serial communications to display at 9600 bps:
  //Serial.begin(9600);

  
  //sensors.begin();/* Initialisieren der Dallas Temperature library */
  //sensors.setResolution(TEMP_12_BIT); // Genauigkeit auf 12-Bit setzen
  /*
    The display controller MAX7219 is in power-saving mode on startup,
    we have to do a wakeup call
  */
  display.shutdown(false);
  /* Set the brightness to a medium value */
  display.setIntensity(15);
  /* and clear the display */
  display.clearDisplay();
  display.setChar(5, 'o', false);
  display.setChar(4, 'n', false);
  //sensors.begin();/* Initialisieren der Dallas Temperature library */
  //sensors.setResolution(TEMP_12_BIT); // Genauigkeit auf 12-Bit setzen
  //Sensor 1:  0x28, 0xAA, 0x26, 0x97, 0x06, 0x00, 0x00, 0x5F

  toneAC(2500);
  delay(120);
  toneAC(3000);
  delay(120);
  toneAC(3800);
  delay(120);
  noToneAC();
  display.setIntensity(5);

  lastmillis = millis();
  wdt_enable(WDTO_4S);     //4 s Watchdog
  wdt_reset();
}
//-----------------------------------------------------------------------------
void loop()
//-----------------------------------------------------------------------------
{
  const unsigned int T_TURN_L  = 15000L;     // 15s rückwärts drehen
  const unsigned int T_TURN_R  = 65000L;     //  vorwärts drehen (mit Lüfter)
  const unsigned int T_PAUSE = 65000L;     // 65s warten
  const unsigned int T_SHORT_TURN = 8000L; // 8s kurz drehen
  static long int countdown;     //Allg. Timer
  static long int countdown2;    //Motor umpolen Timer
  static int countdownTone;      //Sound Timer
  static int startCountdownMS = 5000; //Wartezeit bis zum Start
  static bool umpolen = false;
  static bool linksrum = false;
  static int s = 0;
  static byte tic = 0;
  static bool toggle = false;
  static int count=0; //Zähle Auflockerzyklen
  static int hz=4000;
  if ( millis() - lastmillis >= CYCLE_TIME_MS ) { //Intervall rum
    lastmillis += CYCLE_TIME_MS;

    tic++;
    if (tic > 3) { //Entprellt Türschalter
      tic = 0;
      toggle = !toggle; digitalWrite(DO_LED_Run, toggle);
      if (TUER_IST_AUF) {
        MOTOR_AUS;
        LICHT_EIN;
      } else {
        LICHT_AUS;
      }
    }
    //every second: display remaining time or message
    s += CYCLE_TIME_MS;
    if ((s >= 1000) || displayNeedsRefresh) {
      s = 0;
      refreshDisplay(false);
      wdt_reset();
    }

    //general timer
    countdown -= CYCLE_TIME_MS;
    if (countdown < 0) countdown = 0;
    countdownTone -= CYCLE_TIME_MS;
    if (countdownTone < 0) countdownTone = 0;

    switch (errorStatus) {
      case 0:
        if ((WASSER_ERROR || TUER_IST_AUF) && (status < 3)) { //Behälter nicht eingesetzt oder Tuer auf und noch nicht in Auflockerphase
            //alles aus
            HEIZUNG_AUS;
            MOTOR_AUS;
            if (status > 0) {
			        toneAC(4000);
              hz=3800;
			        countdownTone = 3000; //Bei fehler: 3s Piepsen
		        }
            errorStatus++;
        }
        break;
        
      default:
        HEIZUNG_AUS;
        MOTOR_AUS;
        if (WASSER_ERROR || TUER_IST_AUF) { //Behälter nicht eingesetzt oder Tuer auf
            countdown = 1000; //Signal muss 1s stabil anstehen
            startCountdownMS = 7000;
        } else {
  		      countdownTone = 0;
        }
        
		    if ((hz < 440) || (0 == countdownTone)) {
		      noToneAC(); 
		    }  else {
		      hz-=20;
          toneAC(hz);
		    }

        disp_door = TUER_IST_AUF && (status < 13);   //13: Fertig
        disp_h2o = WASSER_ERROR;
        if ((0 == countdown) || (status >= 13)) { //Behälter eingesetzt, Tür ist zu (seit 1s)
            errorStatus = 0;
            //Motor wird gleich durch umpolen eingeschaltet, da countdown 0 ist.
        }
        break;
    }
    if (0 == status) { //Solange nicht gestartet: Auch bei Tür offen/Wasserbehälter fehlt:  das Poti abfragen
      if (readTimeValue()) {
        startCountdownMS = 5000;
      }
    }
    if (0 == errorStatus) {
      if ((status > 0) && (remainingMilliseconds > 0)) {
        remainingMilliseconds -= CYCLE_TIME_MS;
      } else {
        startCountdownMS -= CYCLE_TIME_MS;
        if (startCountdownMS < 0) startCountdownMS = 0;
      }

      switch (status) {
        case 0: //Warte auf Start
          if (readTimeValue()) {
            startCountdownMS = 5000;
          }
          if (0 == startCountdownMS) {
            MOTOR_R;
            linksrum = false;
            countdown = T_TURN_R;
            if (remainingMilliseconds > 590000) {
              HEIZUNG_EIN;
              status++;
            } else { //kalt laufen
              status = 2;
            }
          }
          break;
        case 1: //WARM: Laufe links+rechts rum
          if (!countdown) {
            if (remainingMilliseconds < 600000) { //10 min
              HEIZUNG_AUS;
              status++;
              break;
            }
            if (linksrum) { //wird gleich beim umpolen rechtsrum
              countdown = T_TURN_R;
              HEIZUNG_EIN;
            } else {
              countdown = T_TURN_L;
              HEIZUNG_AUS;
            }
            umpolen = true;
            display.setIntensity(5);
          }
          break;

        case 2: //Laufe KALT
          HEIZUNG_AUS;
          if (!countdown) {
            if (linksrum) {  //wird gleich beim umpolen rechtsrum
              countdown = T_TURN_R;
            } else {
              countdown = T_TURN_L;
            }
            umpolen = true;
          }
          if (remainingMilliseconds < 800) {
            umpolen = false;
            MOTOR_AUS;
            countdown = 10000L; //10s piepsen
            display.setIntensity(10);
            status++;
            
          }
          break;
        case 3: //Summer
          disp_end = true;
          disp_time = false;
          if ((countdown % 600) <= CYCLE_TIME_MS) {
            toneAC(random(3700, 3900));
          }
          if (!countdown) {
            noToneAC();
            countdown = 2000L;
            status++;
          }
          if (TUER_IST_AUF) {
            status = 13;
          }
          break;
        case 4: //Pause Auflockern
          disp_end = true;
          disp_time = false;
          if (!countdown) {
            umpolen = true;  //Schaltet Motor EIN
            toneAC(3800);
            countdown = T_SHORT_TURN;
            status++;
          }
          if (TUER_IST_AUF) {
            status = 13;
          }
          break;

        case 5://Auflockern + Summer
          disp_end = true;
          disp_time = false;
          if ((countdown % 1000) <= CYCLE_TIME_MS) {
            toneAC(random(3300, 4300));
          }
          if (!countdown) {
            MOTOR_AUS;
            noToneAC();
            countdown = T_PAUSE;
            count++;
            if (count > 20) {  //Nach ca. 30 Minuten auflockern: Aufgeben und Programm beenden
              status=13;
            } else status--;
          }

          if (TUER_IST_AUF) {
            status = 13;
          }
          break;

        case 13: //Fertig
          noToneAC();
          umpolen = false;
          if (digitalRead(DO_MOTOR_TRIAC)) {
              digitalWrite(DO_MOTOR_TRIAC,  LOW); 
              delay(50);
          } 
          digitalWrite(DO_MOTOR_LINKS,  HIGH); 
          digitalWrite(DO_MOTOR_RECHTS, HIGH);
          
          HEIZUNG_AUS;
            
          disp_time = false;
          disp_door = false;
          disp_fluff = true;
          disp_h2o = true;
          disp_end = true;
          wdt_disable(); //Jetzt isses egal wenn der Prozessor stehenbleibt.
          break;
          
        default:
          status = 13;
		  break;
      }//switch(status)
    }//if 0==errorStatus

    //----- Motor ggf. umpolen -----
    switch (MotorStatus) {
      case 0:
        if (umpolen) { //Motor aus
          MOTOR_AUS;
          countdown2 = 2000;
          MotorStatus++;
        }
        break;
      case 1:     //warte bis Motor steht
        countdown2 -= CYCLE_TIME_MS;
        if (countdown2 <= 0)  MotorStatus++;
        break;
      case 2:  //  umpolen
        linksrum = !linksrum;
        if (status < 13) {
          if (linksrum) {
            MOTOR_L;
          } else {
            MOTOR_R;
          }
        }
        umpolen = false;
        countdown2 = 5000;
        MotorStatus++;
        break;
      case 3: //Zur Sicherheit: Mindestzeit warten bis zum nächsten umpolen (nötig z.B. bei Wackelkontakt Tür)
        countdown2 -= CYCLE_TIME_MS;
        if (countdown2 <= 0) MotorStatus = 0;
        break;
      default:
        MotorStatus = 0;
    }// switch(MotorStatus)

    if (displayNeedsRefresh)  refreshDisplay(true);

  }//if millis  (intervall rum)
}//loop
//EOF

